/*
** Renderer.h
**
** Header for Renderer.c
**
** sam-lo_p@epita.fr
*/

#include<fcntl.h>
#include<stdlib.h>
#include<string.h>

#include"DspLib.h"
#include"DebugLib.h"
#include"MixerProtos.h"
#include"PlayBuffers.h"
#include"WaveHeader.h"
#include"MixerKernel.h"

typedef struct s_dsp_save t_dsp_save;
struct s_dsp_save
{
  t_dsp*      dsp;
  t_dsp_save* next_dsp_save;
}; // s_dsp_save

typedef struct s_renderer t_renderer;
struct s_renderer
{
  t_dsp*        dsp;
  t_dsp_save*   dsp_save;
  t_main_mixer* main_mixer;
};

t_renderer* renderer_new( // Creates a new renderer
			 t_main_mixer*, // main mixer
			 char*         // name of the target ms WAV file
			 );

int renderer_destroy( // Destroys a renderer
		     t_renderer* // renderer to be destroyed
		     );

int renderer_update( // Updates buffers
		    t_renderer* // renderer to be updated
		    );
